define(["exports", "deps/regenerator"], function (exports) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.run = exports.name = undefined;

  function _asyncToGenerator(fn) {
    return function () {
      var gen = fn.apply(this, arguments);
      return new Promise(function (resolve, reject) {
        function step(key, arg) {
          try {
            var info = gen[key](arg);
            var value = info.value;
          } catch (error) {
            reject(error);
            return;
          }

          if (info.done) {
            resolve(value);
          } else {
            return Promise.resolve(value).then(function (value) {
              step("next", value);
            }, function (err) {
              step("throw", err);
            });
          }
        }

        return step("next");
      });
    };
  }

  var name = exports.name = "core/seo";

  var run = exports.run = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(conf, doc, cb) {
      var firstParagraph, insertMetaDescription;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // This is not critical, so let's continue other processing first
              cb();
              _context.next = 3;
              return doc.respecIsReady;

            case 3:
              firstParagraph = doc.querySelector("#abstract p:first-of-type");

              if (firstParagraph) {
                _context.next = 6;
                break;
              }

              return _context.abrupt("return");

            case 6:
              insertMetaDescription = makeDescriptionInserter(firstParagraph);

              if (window.requestIdleCallback) {
                window.requestIdleCallback(insertMetaDescription);
              } else {
                insertMetaDescription();
              }

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function run(_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();

  function makeDescriptionInserter(firstParagraph) {
    return function () {
      // Normalize whitespace: trim, remove new lines, tabs, etc.
      var doc = firstParagraph.ownerDocument;
      var content = firstParagraph.textContent.replace(/\s+/, " ").trim();
      var metaElem = doc.createElement("meta");
      metaElem.name = "description";
      metaElem.content = content;
      doc.head.appendChild(metaElem);
    };
  }
});
//# sourceMappingURL=seo.js.map